#!/usr/bin/python
# -*- coding: iso-8859-15 -*-
#-------------------------------python-------------------------eq2+.py--#
#                                                                       #
#              Equazioni di grado superiore al secondo                  #
#                                                                       #
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#--Daniele Zambelli--------------GPL-----------------------------2006---#

"""
Eq. di grado superiore al secondo
"""

from __future__ import print_function, division

if __name__ == "__main__" :
  import sys
  sys.path.append(sys.path[0][:-9])

from symbbase import MultiOutputBase
from fract import Fraction
from polynx import Polynx
import esbase as eb
#import random

STR = [r'{0} = 0',
       r'nroot{{{0}}}{{{1}}}',
       r'-+ nroot{{{0}}}{{{1}}}',
       r'\\sqrt[{0}]{{{1}}}',
       r'\\mp \\sqrt[{0}]{{{1}}}']

#def result_1(exe, res):
#    if eb.Esbase.out_format == eb.ODT:
#        e_str = '{0} = 0'
#        r_str = 'left [{0}; {1} right ]'
#    elif eb.Esbase.out_format == eb.TEX:
#        e_str = '{0} = 0'
#        r_str = '\left [{0}; {1} right ]'
#    return (e_str.format(exe),
#            r_str.format(res0, res1))
#
#def result_2(exe, res0, res1):
#    if eb.Esbase.out_format == eb.ODT:
#        e_str = '{0} = 0'
#        r_str = 'left [{0}; {1} right ]'
#    elif eb.Esbase.out_format == eb.TEX:
#        e_str = '{0} = 0'
#        r_str = r'\left [{0}; {1} \right ]'
#    return (e_str.format(exe),
#            r_str.format(res0, res1))

def exe_01_eqBinrrcz(val_mi, val_ma):
    """Eq. binomie"""
    def out_odt():
        print('------------------> odt')
        i_ese_str = 0
        if eb.odd(n):
            i_res_str = 1
        else:
            i_res_str = 2
        return i_ese_str, i_res_str
    def out_tex():
        print('------------------> tex')
        i_ese_str = 0
        if eb.odd(n):
            i_res_str = 3
        else:
            i_res_str = 4
        return i_ese_str, i_res_str
    f = eb.rrnoval(val_mi/2, val_ma/2, [0])
    a = eb.rrnoval(val_mi/2, val_ma/2, [0]) * f
    b = eb.rrnoval(val_mi/2, val_ma/2, [0]) * f
    n = eb.rrnoval(3, 6)
    i_ese_str, i_res_str = (out_odt, out_tex)[eb.Esbase().out_format]()
    return (STR[i_ese_str].format(eb.binomio(n, a, b)),
            STR[i_res_str].format(n, Fraction(-b, a)))

#def exe_01_eqBinrrcz(val_mi, val_ma):
#    """Eq. binomie"""
#    f = eb.rrnoval(val_mi/2, val_ma/2, [0])
#    a = eb.rrnoval(val_mi/2, val_ma/2, [0]) * f
#    b = eb.rrnoval(val_mi/2, val_ma/2, [0]) * f
#    n = eb.rrnoval(3, 6)
#    out_format = eb.Esbase().out_format
#    if out_format == eb.ODT:
#        i_ese_str = 0
#        if eb.odd(n):
#          i_res_str = 1
#        else:
#          i_res_str = 2
#    elif out_format == eb.TEX:
#        i_ese_str = 0
#        if eb.odd(n):
#          i_res_str = 3
#        else:
#          i_res_str = 4
#    return (STR[i_ese_str].format(eb.binomio(n, a, b)),
#            STR[i_res_str].format(n, Fraction(-b, a)))

def exe_02_eqBinrqcz(val_mi, val_ma):
    """Eq. binomie rad. razionali coeff. interi"""
    a, b = eb.coppiaprimi(val_mi/2, val_ma/2, [0], [0])
    f = eb.rrnoval(val_mi/2, val_ma/2, [0])
    n = eb.rrnoval(3, 6)
    an = f * a ** n
    bn = f * b ** n
    if eb.even(n):
        bn = eb.randsign() * bn
        a = abs(a)
        b = -abs(b)
    out_format = eb.Esbase().out_format
    if out_format == eb.ODT:
        e_str = '{0} = 0'
        if eb.odd(n):
          r_str = '{0}'
        else:
            if an * bn > 0:
                r_str = '-+ {0}i'
            else:
                r_str = '-+ {0}'
    elif eb.Esbase.out_format == eb.TEX:
        if eb.odd(n):
          r_str = '{0}'
        else:
            if an * bn > 0:
                r_str = r'\mp {0}i'
            else:
                r_str = r'\mp {0}'
    return (e_str.format(eb.binomio(n, an, bn)),
            r_str.format(Fraction(-b, a)))

def exe_03_eqBiquadrzcz(val_mi, val_ma):
    """Eq. biquadratiche: rad. intere, coeff. interi"""
    a, b = eb.coppiaprimi(val_mi/2, val_ma/2, [0], [0])
    qa = a * abs(a)
    qb = b * abs(b)
    p0 = Polynx([1, qa])
    p1 = Polynx([1, qb])
    e = p0 * p1
    c = e.coeff
    c.reverse()
    e = Polynx([c[0], 0, c[1], 0, c[2]])
    if a>0:  ris1 = "%s i" % a
    else:    ris1 = "%s" % -a
    if b>0:  ris2 = "%s i" % b
    else:    ris2 = "%s" % -b
    r = (ris1, ris2)
    ese = '%s = 0' % e
    ris = 'left [-+%s; -+%s right ]' % r

def exe_04_eqTrirzcz(val_mi, val_ma):
    """Eq. trinomia: rad. intere, coeff. interi"""
    a, b = eb.coppiaprimi(val_mi/2, val_ma/2, [0], [0])
    ca = a * a * a
    cb = b * b * b
    p0 = Polynx([1, ca])
    p1 = Polynx([1, cb])
    e = p0 * p1
    c = e.coeff
    c.reverse()
    e = Polynx([c[0], 0, 0, c[1], 0, 0, c[2]])
    r = (-a, -b)
    ese = '%s = 0' % e
    ris = 'left [%s; %s right ]' % r

def exe_05_eq3rqcz(val_mi, val_ma):
    """Eq. 3 scomponibile: rad. intere, coeff. interi"""
    a, b = eb.coppiaprimi(val_mi/2, val_ma/2, [0], [0])
    c = eb.rrnoval(val_mi/2, val_ma/2, [0])
    d = eb.rrnoval(val_mi/2, val_ma/2, [0])
    p0 = eb.binomio(2, a, b)
    p1 = Polynx([c, d])
    e = p0 * p1
    r = (Fraction(-b, a), Fraction(-d, c))
    ese = '%s = 0' % e
    if r[0]>0:
      ris = 'left [-+ sqrt %s; %s right ]' % r
    else:
      r = (-r[0], r[1])
      ris = 'left [-+ sqrt %s i; %s right ]' % r

#def exe_01_eq2(Esbase):
#
#    ese = '%s= 0' % e
#    ris = 'left [%s; %s right ]' % r
#
#class Eq2cq(Eq2):
#
#  def genera():
#    co = random.choice(e.coeff)
#    if co:
#      di = random.choice(divisors(co))
#      e/=di
#    Eq2.genera()

def main():
    exe=(exe_01_eqBinrrcz, exe_02_eqBinrqcz, exe_03_eqBiquadrzcz,
       exe_04_eqTrirzcz, exe_05_eq3rqcz)
    for ese in exe:
        print(ese.__doc__)
        exbas = eb.Esbase()
        exbas.genera_n(ese, -10, +10, 5)
        for out_format in range(2):
            print('out_format:', out_format)
            exbas.out_format = out_format
            print('Fraction().out_format:', Fraction().out_format)
            print('Polynx().out_format:', Polynx().out_format)
            for layout in range(2):
                print('layout:', layout)
                eb.Esbase.layout = layout
                print(exbas)
                print()
    

if __name__ == "__main__" :
    main ()
