#!/usr/bin/env python
# -*- coding: iso-8859-15 -*-
#------------------------------python-------------------------genes.py--#
#                                                                       #
#                      Generatore di esercizi                           #
#                                                                       #
# Copyright (c) 2013 Daniele Zambelli
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#--Daniele Zambelli-------------GPL-------------------------------2013--#

"""
Math exercises generator.
"""

from __future__ import print_function, division
import os, sys
try:
    import Tkinter as tk
    #import FileDialog as fd
    import tkFileDialog as tkfd
    import tkMessageBox as tkmb
except ImportError:
    import tkinter as tk
    import tkinter.filedialog as tkfd
    import tkinter.messagebox as tkmb

#from fract import Fraction
#from polynx import Polynx
from symbbase import SymBase
from esbase import Esbase

#RIGHEVUOTE=3
LTESTO = 100
HTESTO = 40
COLGRA = '#CFB53B'
COLFRA = '#E6E8FA'
COLGEN = '#8FBC8F'
MI = -12
MA = 12
DIRESE = '/esercizi'
FORMATS = ('open document', 'LaTeX', 'python', 'text')

class GeneseForm: 
    """Main class for generator."""

    def __init__(self, master):
        self.master = master
        self.nomeese = ''
        self.scelta = tk.IntVar()
        self.format = tk.IntVar() # TODO
        self.numese = tk.IntVar()
        self.min = tk.IntVar()
        self.max = tk.IntVar()
        self.num = tk.IntVar()
        self.numese.set(10)
        self.min.set(-12)
        self.max.set(12)
        self.num.set(1)
        self.scelte = []
        self.loadese()
        self.create_widgets(master)

    def loadese(self):
        """Load all math esercises."""
        nfiles = [n_f[:-3] for n_f in os.listdir(os.curdir+DIRESE) if 
                                                            n_f[-3:] == '.py']
        sys.path.append(sys.path[0] + DIRESE)
        for n_f in nfiles:
            mod = __import__(n_f)
    #        attributes = [getattr(mod, name) for name in dir(mod) if name.startswith('exe_')]
            functions = [getattr(mod, name) for name in dir(mod)
                                                  if name.startswith('exe_')]
    #        functions = [obj for obj in attributes if inspect.isfunction(obj)]
            for func in functions:
#                print(func.__name__)
#                print(func.__doc__)
#                print(func(-5, 5))
                self.scelte.append((func.__doc__, mod, func.__name__))
#            print(pippo)
#        for n_f in nfiles:
#            mod = __import__(n_f)
#            print(mod)
#            exenames = [e for e in dir(mod) if e.startswith('gen_')]
#            print(exenames)
#            exelist = __import__(n_f, fromlist=exenames)
#            print(exelist[exenames[0]])
#            for exe in exelist:
#                print(exe.__doc__)
#            print(pippo)
#            exer = [e.split(';') for e in mod.__doc__.strip('\n').split('\n')]
#            for exe in exer:
#                self.scelte.append((exe[0].strip(), mod, exe[1].strip()))

#    def loadese(self):
#        """Load all math esercises."""
#        nomifile = [nf[:-3] for nf in os.listdir(os.curdir+DIRESE) if 
#                                                            nf[-3:] == '.py']
#        sys.path.append(sys.path[0] + DIRESE)
#        modules = [__import__(nf) for nf in nomifile]
#        for mod in modules:
#            exer = [e.split(';') for e in mod.__doc__.strip('\n').split('\n')]
#            for exe in exer:
#                self.scelte.append((exe[0].strip(), mod, exe[1].strip()))

    def create_widgets(self, master):
        """Create all widgets."""

        def insor(master, row, col, text, var=None):
            """Inserisce all'interno del master m nella riga r un entry
            formato da un'etichetta t, seguita da un oggetto Entry collegato
            alla variabile tv."""
            sticky = tk.W + tk.E
            width = 5 
            tk.Label(master, text=text, anchor=tk.W).grid(row=row, 
                                                          column=col,
                                                          sticky=sticky)
            entry = tk.Entry(master, width=width, textvariable=var)
            entry.grid(row=row, column=col+1, sticky=sticky)
            return entry

        def make_menufile(mbar):
            """Make menu File."""
            fileb = tk.Menubutton(mbar, text='File', underline=0)
            fileb.pack(side=tk.LEFT, padx='2m')
            fileb.menu = tk.Menu(fileb)
            fileb.menu.add_command(label='Genera',
                                   underline=0, command=self.genera)
            fileb.menu.add_command(label='Salva',
                                   underline=0, command=self.salva)
            fileb.menu.add_command(label='Sava con nome',
                                   underline=9, command=self.salvacn)
            fileb.menu.add_command(label='Carica',
                                   underline=0, command=self.carica)
            fileb.menu.add_command(label='Cancella',
                                   underline=1, command=self.cancella)
            fileb.menu.add('separator')
            fileb.menu.add_command(label='Esci',
                                   underline=1, command=self.basta)
            fileb['menu'] = fileb.menu
            return fileb

        def make_menuese(mbar, ese):
            """Make menu Ese."""
            eseb = tk.Menubutton(mbar, text='Esercizi', underline=0)
            eseb.pack(side=tk.LEFT, padx='2m')
            eseb.menu = tk.Menu(eseb)
            for i, text in enumerate(ese):
                eseb.menu.add_radiobutton(label='%2d. %s' % (i, text),
                                        variable=self.scelta, value=i)
            eseb['menu'] = eseb.menu
            return eseb

        def make_menuformat(mbar, formats):
            """Make menu Format."""
            formb = tk.Menubutton(mbar, text='Formato', underline=0)
            formb.pack(side=tk.LEFT, padx='2m')
            formb.menu = tk.Menu(formb)
            for i, text in enumerate(formats):
                formb.menu.add_radiobutton(label='{0:2d}. {1}'.format(i, text),
                                           variable=self.format, value=i)
            formb['menu'] = formb.menu
            return formb

        def createsto(master, row, col, wtext, htext, color):
            """Create text box."""
            xsb = 0
            ysb = 1
            textb = tk.Text(master, width=wtext, height=htext,
                            background=color, wrap=tk.WORD)
            if xsb:
                xscroll = tk.Scrollbar(master, orient=tk.HORIZONTAL)
                xscroll.grid(row=row+1, column=col, columnspan=2, 
                             sticky=tk.E+tk.W)
                textb['xscrollcommand'] = xscroll.set
                xscroll['command'] = textb.xview
            if ysb:
                yscroll = tk.Scrollbar(master, orient=tk.VERTICAL)
                yscroll.grid(row=row, column=col+1, sticky=tk.N+tk.S)
                textb['yscrollcommand'] = yscroll.set
                yscroll['command'] = textb.yview
            textb.grid(row=row, column=col, sticky=tk.N+tk.S+tk.E+tk.W)
            return textb

        def creabottoni(master, bottons, row=0, col=0, irow=1, icol=0):
            """Create bottons."""
            for bott in bottons:
                button = tk.Button(master, text=bott[0], command=bott[1])
                button.grid(row=row, column=col)
                row += irow
                col += icol

# main createWidgets
        mbar = tk.Frame(master, background=COLGRA,)
        mbar.grid(row=0, column=0, columnspan=2, sticky=tk.W)
        menu_file = make_menufile(mbar)
        scelte = (e[0] for e in self.scelte)
        menu_ese = make_menuese(mbar, scelte)
        mbar.tk_menuBar(menu_file, menu_ese)
        menu_form = make_menuformat(mbar, FORMATS)
        mbar.tk_menuBar(menu_file, menu_form)
# frame di bottoni: comandi
        bottonifr = tk.Frame(master, background=COLGEN,)
        bottonifr.grid(row=4, column=0, columnspan=3,
                          sticky=tk.N+tk.S+tk.E+tk.W)
        valorifr = tk.Frame(bottonifr,
                            background=COLGRA, relief=tk.RIDGE, bd=3)
        valorifr.grid(ipady=10)
        insor(bottonifr, 0, 0, "numero esercizi:", var=self.numese)
        insor(bottonifr, 0, 2, "minimo:", var=self.min)
        insor(bottonifr, 0, 4, "massimo:", var=self.max)
        insor(bottonifr, 0, 6, "numera da:", var=self.num)
        bottonigra = (('Genera', self.genera),
                    ('Basta!', self.basta),
                    ('Informazioni', self.info),
                   )
        creabottoni(bottonifr, bottonigra, col=8, irow=0, icol=1)
    # textbox: esercizi
        self.esercizitb = createsto(master, 1, 1, LTESTO, HTESTO, COLGRA)

####
# Metodi chiamati in risposta alla pressine dei bottoni
###
    def genera(self):
        """Generates an exercise."""
        # Leggi i dati
#        Fraction.out_format = self.format.get()
#        Polynx.out_format = self.format.get()
        SymBase.out_format = self.format.get()
        Esbase.out_format = self.format.get()
        selected = self.scelta.get()
        _, mod, nameclass = self.scelte[selected]
        esercizio = getattr(mod, nameclass) # (self.min.get(), self.max.get())
#        numese = self.numese.get()
#        print(self.num.get())
        eb.genera_n(esercizio, self.min.get(), self.max.get(),
                    self.numese.get())
        eb.num = self.num.get()
        self.esercizitb.insert(tk.END, str(eb) + "\n\n")
        self.num.set(eb.num)

    def salva(self):
        """Save text."""
        if self.nomeese == '':
            ofile = tkfd.asksaveasfile(defaultextension='.ese',
                                      filetypes=[('esercizi', '*.ese')],
                                      title='Salva esercizi')
        else:
            ofile = open(self.nomeese, 'w')
        if ofile is not None:
            gra = self.esercizitb.get('0.1', tk.END).encode('latin-1')
            ofile.write(gra)
            self.nomeese = ofile.name
            self.master.title(self.nomeese)
            ofile.close()

    def salvacn(self):
        """Save as."""
        ofile = tkfd.asksaveasfile(defaultextension='.ese',
                                  filetypes=[('esercizi', '*.ese')],
                                  title='Salva esercizi')
        if ofile is not None:
            gra = self.esercizitb.get('0.1', tk.END).encode('latin-1')
            ofile.write(gra)
            self.nomeese = ofile.name
            self.master.title(self.nomeese)
            ofile.close()

    def carica(self):
        """Load."""
        # TODO
        # se ci sono gi esercizi deve chiedere se la si vuole salvare
        ifile = tkfd.askopenfile(defaultextension='.ese',
                                filetypes=[('esercizi', '*.ese')],
                                title='Apri esercizi')
        if ifile is not None:
        # se c' gi una grammatica deve cancellarla
            self.esercizitb.delete("1.0", tk.END)
            self.esercizitb.insert('1.0', ifile.read())
            self.nomeese = ifile.name
            self.master.title(self.nomeese)
            ifile.close()

    def cancella(self):
        """Clear text."""
        self.esercizitb.delete("1.0", tk.END)
        self.num.set(1)
        self.master.title(self.nomeese)

#    def stampagra(self):
#        """Print text."""
#        print "stampagra"

    def basta(self):
        """Exit."""
        self.master.quit()
        self.master.destroy()

    def info(self):
        """Info."""
        tkmb.showinfo("Informazioni", """
Programma scritto in Python,
rilasciato sotto licenza GPL (vedi: www.gnu.org),
da Daniele Zambelli (daniele.zambelli@inwind.it).
Viene diffuso senza alcuna garanzia
nella speranza che possa servire e divertire.

Sono graditi commenti, critiche, suggerimenti...""")

eb = Esbase()
ROOT = tk.Tk()
GeneseForm(ROOT) 
ROOT.mainloop() 

