#!/usr/bin/python
#-------------------------------python---------------------symbbase.py--#
#                                                                       #
#                Base class for symbolic computation                    #
#                                                                       #
#--Daniele Zambelli--------------GPL-----------------------------2013---#

"""
Base class for symbolic computation
"""

from __future__ import print_function, division

VERSION = '0.8'


class MultiOutputBase(object):
    """Base class for Multi format output.
>>> for format in range(4):
...     MultiOutputBase.out_format = format
...     print(MultiOutputBase.out_format)
0
1
2
3
>>> b = MultiOutputBase()
>>> for format in range(4):
...     b.out_format = format
...     print(b.out_format)
0
1
2
3
    """

    _out_format = 0

    def getout_format(self):
        return MultiOutputBase._out_format
    def setout_format(self, out_format):
        MultiOutputBase._out_format = out_format
    out_format = property(getout_format, setout_format)

if __name__ == "__main__":
    import doctest
    doctest.testmod(verbose=True)
